package devmanuals.com;

import java.util.AbstractQueue;
import java.util.Iterator;
import java.util.Queue;
import java.util.LinkedList;
public class AbstractQueueDemo extends AbstractQueue{
	Queue q;
	
	AbstractQueueDemo(){
	q=new LinkedList();
	}
	public boolean offer() {
		System.out.println(q);
		return true;
	}
	public boolean offer(Object e) {
		q.offer(e);
		return true;
	}
	public Iterator iterator() {
		Iterator itr = q.iterator();
		while(itr.hasNext()){
			System.out.println(itr.next());
		}
		return null;
	}
	public int size() {
		System.out.println(q.size());
		return 0;
	}	
	public Object peek() {
		Object o= q.peek();
		System.out.println(o);
		return null;
	}
	public Object poll() {
		Object o = q.poll();
		System.out.println(o);
		return null;
	}
	public static void main(String[] args) {
		AbstractQueueDemo aqd = new AbstractQueueDemo();
		System.out.println("Elements in queue are =");
		aqd.offer("A");
		aqd.offer("B");
		aqd.offer("C");
		aqd.offer("D");
		aqd.offer("E");
		aqd.offer("F");
		aqd.offer("G");
		aqd.offer();
		System.out.println("Displaying elements of queue using iterator =");
		aqd.iterator();
		System.out.println("Size of Queue =");
		aqd.size();
		System.out.println("The head element of Queue =");
		aqd.peek();
		System.out.println("The removed head element =");
		aqd.poll();
		System.out.println("Remaining element of queue");
		aqd.offer();
		System.out.println("Now the size of queue =");
		aqd.size();
	}
}
